"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ngcounter = void 0;
const ngast_1 = require("./deps/ngast");
const utils_1 = require("./utils");
function ngcounter() {
    const projectPath = utils_1.tryGetsProjectPath();
    const workspace = new ngast_1.WorkspaceSymbols(projectPath);
    console.log('Parsing...');
    const allModules = workspace.getAllModules();
    const allPipes = workspace.getAllPipes();
    const allInjectables = workspace.getAllInjectable();
    const allDirectives = workspace.getAllDirectives();
    const allComponents = workspace.getAllComponents();
    const classes = workspace.getClassRecords();
    const listLazyRoutes = workspace.routeAnalyzer.listLazyRoutes();
    utils_1.info(`Modules:`, allModules.length);
    utils_1.info(`Lazy Routes:`, listLazyRoutes.length);
    utils_1.info(`Pipes:`, allPipes.length);
    utils_1.info(`Directives:`, allDirectives.length);
    utils_1.info(`Components:`, allComponents.length);
    utils_1.info(`Injectables:`, allInjectables.length);
    utils_1.info(`Classes:`, classes.length);
}
exports.ngcounter = ngcounter;
//# sourceMappingURL=counter.js.map