"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.tryGetsProjectPath = exports.info = exports.error = void 0;
const minimist = require("minimist");
const chalk = require("chalk");
const fs_1 = require("fs");
exports.error = message => {
    console.error(chalk.default.bgRed.white(message));
};
exports.info = (message, count1, count2) => {
    console.log(chalk.default.green(message) +
        ` ${chalk.default.blue(count1)}` +
        ` ${count2 ? '/ ' + chalk.default.yellowBright(count2) : ''}`);
};
function tryGetsProjectPath() {
    let projectPath = minimist(process.argv.slice(2)).p;
    if (!projectPath) {
        projectPath = './tsconfig.json';
    }
    if (!fs_1.existsSync(projectPath)) {
        exports.error('Cannot find tsconfig at "' + projectPath + '".');
        process.exit(1);
    }
    return projectPath;
}
exports.tryGetsProjectPath = tryGetsProjectPath;
//# sourceMappingURL=utils.js.map